package com.yizhi.custom.api.feign;

import com.yizhi.custom.api.vo.custom.VisibleRangeExportVo;
import com.yizhi.custom.api.vo.domain.ExperiencePoolAuthorizeVo;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;
import java.util.Map;

/**
 * 经验池可见范围接口
 *
 * @author dingxiaowei
 * @date 2018-11-2
 */
@FeignClient(name = "customproject", contextId = "ExperiencePoolAuthorizeClient")
public interface ExperiencePoolAuthorizeClient {
    /**
     * 导入可见范围
     *
     * @param poolAuthorizeList
     * @return
     */
    @PostMapping("/manage/experiencePool/authorize/insert")
    boolean insertExperiencePoolAuthorize(@RequestBody List<ExperiencePoolAuthorizeVo> poolAuthorizeList);

    /**
     * 导出可见范围
     *
     * @param experiencePoolId
     * @return
     */
    @GetMapping("/manage/experiencePool/authorize/list")
    VisibleRangeExportVo listAuthorizes(@RequestParam("experiencePoolId") Long experiencePoolId);

    /**
     * 可见范围列表
     *
     * @param experiencePoolId
     * @return
     */
    @GetMapping("/manage/experiencePool/authorize/view")
    List<Map<String, Object>> getListMap(@RequestParam("experiencePoolId") Long experiencePoolId);

}
