package com.yizhi.custom.api.feign;

import com.yizhi.custom.api.vo.domain.ExperiencePoolLevelVo;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;
import java.util.Map;

/**
 * 经验池等级feign接口
 *
 * @author dingxiaowei
 * @date 2018-11-2
 */
@FeignClient(name = "customproject", contextId = "ExperiencePoolLevelClient")
public interface ExperiencePoolLevelClient {

    /**
     * 设置经验池等级(显示经验池列表)
     *
     * @param poolId
     * @return
     */
    @GetMapping("/manage/experiencePool/level/list")
    List<ExperiencePoolLevelVo> getExperiencePoolLevelList(@RequestParam("poolId") Long poolId);

    /**
     * 查看单个经验池等级
     *
     * @param poolId
     * @return
     */
    @GetMapping("/manage/experiencePool/level/view")
    ExperiencePoolLevelVo getExperiencePoolLevelView(@RequestParam("poolId") Long poolId);

    /**
     * 删除经验池等级
     *
     * @param poolLevelId
     * @return
     */
    @GetMapping("/manage/experiencePool/level/delete")
    boolean deleteExperiencePoolLevel(@RequestParam("poolLevelId") Long poolLevelId);

    /**
     * 新增(更新)经验池等级
     *
     * @param experiencePoolLevel
     * @return
     */
    @GetMapping("/manage/experiencePool/level/insert")
    Map<String, Object> insertExperiencePoolLevel(@RequestBody ExperiencePoolLevelVo experiencePoolLevel);

}
