package com.yizhi.custom.api.feign;

import com.yizhi.custom.api.vo.domain.ExperiencePoolProjectVo;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

/**
 * 经验池关联项目/活动接口
 *
 * @author dingxiaowei
 * @date 2018-11-2
 */
@FeignClient(name = "customproject", contextId = "ExperiencePoolProjectClient")
public interface ExperiencePoolProjectClient {

    /**
     * 查看关联活动ID
     *
     * @param experiencePoolId
     * @return
     */
    @GetMapping("/manage/experiencePool/project/view")
    List<ExperiencePoolProjectVo> getExperiencePoolProjectList(@RequestParam("experiencePoolId") Long experiencePoolId);

}
