package com.yizhi.custom.api.feign;

import com.yizhi.custom.api.vo.custom.ExperienceRulesVO;
import com.yizhi.custom.api.vo.domain.ProjectActivityExperienceVo;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

/**
 * 经验池项目关联活动feign接口
 *
 * @author dingxiaowei
 * @date 2018-11-5
 */
@FeignClient(name = "customproject", contextId = "ProjectActivityExperienceClient")
public interface ProjectActivityExperienceClient {

    /**
     * @param projectActivityExperienceList
     * @return
     */
    @PostMapping("/manage/experiencePool/projectActivity/insert")
    boolean insertProjectActivityExperienceList(@RequestBody List<ProjectActivityExperienceVo> projectActivityExperienceList);

    @GetMapping("/manage/experiencePool/projectActivity/getRules")
    List<ExperienceRulesVO> getExperienceRules(@RequestParam("poolId") Long poolId);
}
