package com.yizhi.custom.api.feign;

import com.yizhi.custom.api.param.PurchaseProductsParam;
import com.yizhi.custom.api.vo.custom.ProductVO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

/**
 * 消费商品feign接口
 *
 * @author dingxiaowei
 * @date 2019-09-19
 */
@FeignClient(name = "customproject", contextId = "PurchaseProductClient")
public interface PurchaseProductClient {

    /**
     * 自定义项目获取商品信息
     * @param poolId
     * @return
     */
    @GetMapping("/api/my/getProducts")
    ProductVO getProducts(@RequestParam("poolId") Long poolId);

    /**
     * 自定义项目购买商品
     * @param param
     * @return
     */
    @PostMapping("/api/my/purchaseProducts")
    String purchaseProducts(@RequestBody PurchaseProductsParam param);
}
