package com.yizhi.custom.api.feign;

import com.yizhi.core.application.context.RequestContext;
import com.yizhi.custom.api.vo.domain.StudentExperienceVo;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

/**
 * 经验池项目关联活动feign接口
 *
 * @author dingxiaowei
 * @date 2018-11-12
 */
@FeignClient(name = "customproject", contextId = "StudentExperienceClient")
public interface StudentExperienceClient {

    @PostMapping("/manage/experiencePool/studentExperience/insert")
    boolean insertStudentExperienceList(@RequestBody List<StudentExperienceVo> studentExperienceList);

    @GetMapping("/manage/experiencePool/studentExperience/push")
    boolean pushStudentExperience(@RequestParam("experiencePoolId") Long experiencePoolId,
                                  @RequestParam("activityId") Long activityId,
                                  @RequestParam("activityName") String activityName,
                                  @RequestParam("activityType") Integer activityType,
                                  @RequestParam("accountIds") List<Long> accountIds,
                                  @RequestBody RequestContext requestContext);
}