package com.yizhi.custom.api.vo.domain;


import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 经验池主体
 * </p>
 *
 * @author dingxiaowei
 * @since 2018-11-02
 */
@Data
@ApiModel(value = "ExperiencePoolVo", description = "自定义项目经验池主体表")
public class ExperiencePoolVo {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "主键ID")
    private Long id;

    @ApiModelProperty(value = "经验池编码")
    private String experiencePoolNo;

    @ApiModelProperty(value = "经验池名称")
    private String experiencePoolName;

    @ApiModelProperty(value = "0删除 1 草稿 2上架")
    private Integer state;

    @ApiModelProperty(value = " 1手工输入 2外部导入")
    private Integer experiencePoolType;

    @ApiModelProperty(value = "可见范围:1 全平台可见 2 指定学员")
    private Integer visibleRange;

    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ApiModelProperty(value = "创建人ID")
    private Long createById;

    @ApiModelProperty(value = "创建人名字")
    private String createByName;

    @ApiModelProperty(value = "修改时间")
    private Date updateTime;

    @ApiModelProperty(value = "修改人ID")
    private Long updateById;

    @ApiModelProperty(value = "修改人名字")
    private String updateByName;

    @ApiModelProperty(value = "企业_ID")
    private Long companyId;

    @ApiModelProperty(value = "部门_ID")
    private Long orgId;

    @ApiModelProperty(value = "站点_ID")
    private Long siteId;


}
