package com.yizhi.application.controller;


import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.yizhi.application.domain.ExperiencePool;
import com.yizhi.application.domain.ExperiencePoolAuthorize;
import com.yizhi.application.service.IExperiencePoolAuthorizeService;
import com.yizhi.application.service.IExperiencePoolService;
import com.yizhi.custom.api.feign.ExperiencePoolAuthorizeClient;
import com.yizhi.custom.api.vo.custom.VisibleRangeExportVo;
import com.yizhi.custom.api.vo.domain.ExperiencePoolAuthorizeVo;
import com.yizhi.exam.application.vo.exam.VisibleRangeExport;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.*;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author ding
 * @since 2018-11-06
 */
@RestController
@RequestMapping("/manage/experiencePool")
public class ExperiencePoolAuthorizeController implements ExperiencePoolAuthorizeClient {

    @Autowired
    private IExperiencePoolAuthorizeService poolAuthorizeService;

    @Autowired
    private IExperiencePoolService poolService;

    @Override
    @PostMapping("/authorize/insert")
    public boolean insertExperiencePoolAuthorize(@RequestBody List<ExperiencePoolAuthorizeVo> poolAuthorizeList) {
        List<ExperiencePoolAuthorize> list = new ArrayList<>();
        if (!poolAuthorizeList.isEmpty()){
            for (ExperiencePoolAuthorizeVo ex:poolAuthorizeList) {
                ExperiencePoolAuthorize ep=new ExperiencePoolAuthorize();
                BeanUtils.copyProperties(ex,ep);
                list.add(ep);
            }
        }

        return poolAuthorizeService.insertAuthorizeList(list);
    }

    @Override
    @GetMapping("/authorize/list")
    public VisibleRangeExportVo listAuthorizes(Long experiencePoolId) {

        VisibleRangeExport visibleRangeExport = new VisibleRangeExport();
        List<Long> accountIds = new ArrayList<>();
        List<Long> orgIds = new ArrayList<>();
        Map<Long, SortedMap<String, String>> map = new HashMap<>();
        SortedMap<String, String> sortedMap = null;
        //查出可见范围列表
        ExperiencePoolAuthorize poolAuthorize = new ExperiencePoolAuthorize();
        poolAuthorize.setExperienceId(experiencePoolId);
        EntityWrapper<ExperiencePoolAuthorize> entityWrapper = new EntityWrapper<>(poolAuthorize);
        List<ExperiencePoolAuthorize> list = poolAuthorizeService.selectList(entityWrapper);

        //查出经验池名称
        ExperiencePool experiencePool = new ExperiencePool();
        experiencePool = poolService.selectById(experiencePoolId);

        //将导出所需要具体关键字装入实体类中
        if (CollectionUtils.isNotEmpty(list)) {
            for (ExperiencePoolAuthorize authorize : list) {
                if (authorize.getType() == 1) {
                    sortedMap = new TreeMap<String, String>();
                    accountIds.add(authorize.getRelationId());
                    sortedMap.put("group", authorize.getGroup());
                    sortedMap.put("batchNo", authorize.getBatchNo());
                    sortedMap.put("note", authorize.getNote());
                    map.put(authorize.getRelationId(), sortedMap);
                } else if (authorize.getType() == 2) {
                    orgIds.add(authorize.getRelationId());
                }
            }
            visibleRangeExport.setAccountIds(accountIds);
            visibleRangeExport.setOrgIds(orgIds);
            visibleRangeExport.setMap(map);
            if (null != experiencePool) {
                visibleRangeExport.setBizName(experiencePool.getExperiencePoolName());
            }
        } else {
            if (null != experiencePool) {
                visibleRangeExport.setBizName(experiencePool.getExperiencePoolName());
            }
        }
        VisibleRangeExportVo v=new VisibleRangeExportVo();
        BeanUtils.copyProperties(visibleRangeExport,v);
        return v;
    }

    @Override
    @GetMapping("/authorize/view")
    public List<Map<String, Object>> getListMap(Long experiencePoolId) {
        return poolAuthorizeService.getListMap(experiencePoolId);
    }

}

