package com.yizhi.application.controller;


import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.application.domain.ExperiencePool;
import com.yizhi.application.service.IExperiencePoolService;
import com.yizhi.custom.api.feign.ExperiencePoolClient;
import com.yizhi.custom.api.param.ExperiencePoolParam;
import com.yizhi.custom.api.vo.custom.ExperiencePoolVoAutorizeAndProjectVO;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import com.yizhi.custom.api.vo.domain.ExperiencePoolVo;
import com.yizhi.custom.api.vo.domain.ProjectActivityExperienceVo;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author ding
 * @since 2018-11-06
 */
@RestController
@RequestMapping("/manage/experiencePool")
public class ExperiencePoolController implements ExperiencePoolClient {

    @Autowired
    private IExperiencePoolService poolService;

    @Override
    @GetMapping("/list")
    public Page<ExperiencePoolVo> getExperiencePoolList(@RequestBody ExperiencePoolParam param) {
        Page<ExperiencePool> page = poolService.getExperiencePoolList(param);
        Page<ExperiencePoolVo> pageVo=new Page<>(page.getCurrent(),page.getSize());
        List<ExperiencePool> list=page.getRecords();
        List<ExperiencePoolVo> lists=new ArrayList<>();
        if (!list.isEmpty()){
            for (ExperiencePool c:list) {
                ExperiencePoolVo cc=new ExperiencePoolVo();
                BeanUtils.copyProperties(c,cc);
                lists.add(cc);
            }
        }
        pageVo.setRecords(lists);
        return pageVo;
    }

    @Override
    @GetMapping("/view")
    public ExperiencePoolVoAutorizeAndProjectVO getExperiencePoolView(Long poolId) {

        return poolService.getExperiencePoolView(poolId);
    }

    @Override
    @GetMapping("/delete")
    public boolean deleteExperiencePool(Long poolId) {

        return poolService.deleteById(poolId);
    }

    @Override
    public boolean insertExperiencePoolList(@RequestBody List<ProjectActivityExperienceVo> projectActivityExperienceList) {
        return false;
    }

    @Override
    public List<ProjectActivityExperienceVo> getActivityExperienceList(Long poolId) {
        return null;
    }

    @Override
    @PostMapping("/save")
    public Map<String, Object> insertExperiencePoolAuthorizeAndProject(
            @RequestBody ExperiencePoolVoAutorizeAndProjectVO poolAutorizeAndProjectVO) {
        return poolService.insertPoolAuthorizeAndProject(poolAutorizeAndProjectVO);
    }

    @Override
    @GetMapping("/complete")
    public boolean completeExperiencePool(Long poolId) {

        return poolService.complete(poolId);
    }
}

