package com.yizhi.application.controller;


import java.util.ArrayList;
import java.util.List;

import com.yizhi.application.domain.ExperiencePoolProject;
import com.yizhi.application.mapper.ExperiencePoolProjectMapper;
import com.yizhi.custom.api.vo.domain.ExperiencePoolProjectVo;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.yizhi.custom.api.feign.ExperiencePoolProjectClient;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author ding
 * @since 2018-11-06
 */
@RestController
@RequestMapping("/manage/experiencePool")
public class ExperiencePoolProjectController implements ExperiencePoolProjectClient {

	@Autowired
	private ExperiencePoolProjectMapper experiencePoolProjectMapper;

	@Override
	@GetMapping("/project/view")
	public List<ExperiencePoolProjectVo> getExperiencePoolProjectList(Long experiencePoolId) {
		List<ExperiencePoolProject> list = experiencePoolProjectMapper.getExperiencePoolProjectList(experiencePoolId);
		List<ExperiencePoolProjectVo> levelVos=new ArrayList<>();
		if (!list.isEmpty()) {
			for (ExperiencePoolProject pl : list) {
				ExperiencePoolProjectVo pls=new ExperiencePoolProjectVo();
				BeanUtils.copyProperties(pl,pls);
				levelVos.add(pls);
			}
		}
		return levelVos;
	}

}

