package com.yizhi.application.controller;


import java.util.ArrayList;
import java.util.List;

import com.yizhi.application.domain.ProjectActivityExperience;
import com.yizhi.application.service.IProjectActivityExperienceService;
import com.yizhi.custom.api.vo.custom.ExperienceRulesVO;
import com.yizhi.custom.api.vo.domain.ProjectActivityExperienceVo;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.yizhi.custom.api.feign.ProjectActivityExperienceClient;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author ding
 * @since 2018-11-06
 */
@RestController
@RequestMapping("/manage/experiencePool/projectActivity")
public class ProjectActivityExperienceController implements ProjectActivityExperienceClient {

    @Autowired
    private IProjectActivityExperienceService activityExperienceService;

    @Override
    @PostMapping("/insert")
    public boolean insertProjectActivityExperienceList(@RequestBody List<ProjectActivityExperienceVo> projectActivityExperienceList) {
        List<ProjectActivityExperience> list=new ArrayList<>();
        if (!projectActivityExperienceList.isEmpty()) {
            for (ProjectActivityExperienceVo pv : projectActivityExperienceList) {
                ProjectActivityExperience pvs=new ProjectActivityExperience();
                BeanUtils.copyProperties(pv,pvs);
                list.add(pvs);
            }
        }
        return activityExperienceService.insertList(list);
    }

    @Override
    @GetMapping("/getRules")
    public List<ExperienceRulesVO> getExperienceRules(Long poolId) {
        return activityExperienceService.getExperienceRules(poolId);
    }

}

