package com.yizhi.application.controller;


import com.yizhi.application.domain.StudentExperience;
import com.yizhi.application.service.IStudentExperienceService;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.custom.api.feign.StudentExperienceClient;
import com.yizhi.custom.api.vo.domain.StudentExperienceVo;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 项目关联活动经验值表 前端控制器
 * </p>
 *
 * @author dingxiaowei123
 * @since 2018-11-12
 */
@RestController
@RequestMapping("/manage/experiencePool/studentExperience")
public class StudentExperienceController implements StudentExperienceClient {

    @Autowired
    private IStudentExperienceService studentExperienceService;

    @Override
    @PostMapping("/insert")
    public boolean insertStudentExperienceList(@RequestBody List<StudentExperienceVo> studentExperienceList) {
        List<StudentExperience> levelVos=new ArrayList<>();
        if (!studentExperienceList.isEmpty()) {
            for (StudentExperienceVo pl : studentExperienceList) {
                StudentExperience pls=new StudentExperience();
                BeanUtils.copyProperties(pl,pls);
                levelVos.add(pls);
            }
        }
        return studentExperienceService.insertStudentExperienceList(levelVos);
    }

    /**
     * 经验池手动补发经验
     *
     * @param experiencePoolId
     * @return
     */
    @Override
    @GetMapping("/push")
    public boolean pushStudentExperience(Long experiencePoolId, Long activityId, String activityName, Integer activityType, @RequestParam("accountIds") List<Long> accountIds, @RequestBody RequestContext requestContext) {
        return studentExperienceService.pushStudentExperience(experiencePoolId, activityId, activityName, activityType, accountIds, requestContext);
    }


}

