package com.yizhi.application.domain;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 代码包管理主体
 * </p>
 *
 * @author dingxiaowei
 * @since 2018-11-01
 */
@Data
@ApiModel(value = "CodePackageManageVo", description = "")
@TableName("code_package_manage")
public class CodePackageManage {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "主键ID")
	private Long id;

    @ApiModelProperty(value = "代码包名称")
	@TableField("code_package_name")
	private String codePackageName;

    @ApiModelProperty(value = "导入时间")
	@TableField("import_time")
	private Date importTime;

    @ApiModelProperty(value = "访问路径")
	private String url;

    @ApiModelProperty(value = "状态 0 删除 1 有效")
	private Integer state;

    @ApiModelProperty(value = "创建时间")
	@TableField(value = "create_time", fill = FieldFill.INSERT)
	private Date createTime;

    @ApiModelProperty(value = "创建人ID")
	@TableField(value = "create_by_id", fill = FieldFill.INSERT)
	private Long createById;

    @ApiModelProperty(value = "创建人名字")
	@TableField(value = "create_by_name", fill = FieldFill.INSERT)
	private String createByName;

    @ApiModelProperty(value = "修改时间")
	@TableField(value = "update_time", fill = FieldFill.INSERT)
	private Date updateTime;

    @ApiModelProperty(value = "修改人ID")
	@TableField(value = "update_by_id", fill = FieldFill.INSERT)
	private Long updateById;

    @ApiModelProperty(value = "修改人名字")
	@TableField(value = "update_by_name", fill = FieldFill.INSERT)
	private String updateByName;

    @ApiModelProperty(value = "企业_ID")
	@TableField("company_id")
	private Long companyId;

    @ApiModelProperty(value = "部门_ID")
	@TableField("org_id")
	private Long orgId;

    @ApiModelProperty(value = "站点_ID")
	@TableField("site_id")
	private Long siteId;



}
