package com.yizhi.application.domain;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 经验池主体
 * </p>
 *
 * @author dingxiaowei
 * @since 2018-11-02
 */
@Data
@ApiModel(value = "ExperiencePoolVo", description = "自定义项目经验池主体表")
@TableName("experience_pool")
public class ExperiencePool {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "主键ID")
    private Long id;

    @ApiModelProperty(value = "经验池编码")
    @TableField("experience_pool_no")
    private String experiencePoolNo;

    @ApiModelProperty(value = "经验池名称")
    @TableField("experience_pool_name")
    private String experiencePoolName;

    @ApiModelProperty(value = "0删除 1 草稿 2上架")
    private Integer state;

    @ApiModelProperty(value = " 1手工输入 2外部导入")
    @TableField("experience_pool_type")
    private Integer experiencePoolType;

    @ApiModelProperty(value = "可见范围:1 全平台可见 2 指定学员")
    @TableField("visible_range")
    private Integer visibleRange;

    @ApiModelProperty(value = "创建时间")
    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "创建人ID")
    @TableField(value = "create_by_id", fill = FieldFill.INSERT)
    private Long createById;

    @ApiModelProperty(value = "创建人名字")
    @TableField(value = "create_by_name", fill = FieldFill.INSERT)
    private String createByName;

    @ApiModelProperty(value = "修改时间")
    @TableField(value = "update_time", fill = FieldFill.INSERT)
    private Date updateTime;

    @ApiModelProperty(value = "修改人ID")
    @TableField(value = "update_by_id", fill = FieldFill.INSERT)
    private Long updateById;

    @ApiModelProperty(value = "修改人名字")
    @TableField(value = "update_by_name", fill = FieldFill.INSERT)
    private String updateByName;

    @ApiModelProperty(value = "企业_ID")
    @TableField("company_id")
    private Long companyId;

    @ApiModelProperty(value = "部门_ID")
    @TableField("org_id")
    private Long orgId;

    @ApiModelProperty(value = "站点_ID")
    @TableField("site_id")
    private Long siteId;


}
