package com.yizhi.application.domain;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 经验池可见范围主体
 * </p>
 *
 * @author dingxiaowei
 * @since 2018-11-01
 */
@Data
@ApiModel(value = "ExperiencePoolAuthorizeVo", description = "")
@TableName("experience_pool_authorize")
public class ExperiencePoolAuthorize {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "主键ID")
    private Long id;

    @ApiModelProperty(value = "经验池ID")
    @TableField("experience_id")
    private Long experienceId;

    @ApiModelProperty(value = "1 用户 2 部门")
    private Integer type;

    @ApiModelProperty(value = "批次号")
    @TableField("batch_no")
    private String batchNo;

    @ApiModelProperty("组别")
    private String group;


    @ApiModelProperty(value = "范围ID")
    @TableField("relation_id")
    private Long relationId;

    @ApiModelProperty(value = "学员名字或部门名称")
    private String name;

    @ApiModelProperty(value = "创建时间")
    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "创建人ID")
    @TableField(value = "create_by_id", fill = FieldFill.INSERT)
    private Long createById;

    @ApiModelProperty(value = "创建人名字")
    @TableField(value = "create_by_name", fill = FieldFill.INSERT)
    private String createByName;

    @ApiModelProperty(value = "修改时间")
    @TableField(value = "update_time", fill = FieldFill.INSERT)
    private Date updateTime;

    @ApiModelProperty(value = "修改人ID")
    @TableField(value = "update_by_id", fill = FieldFill.INSERT)
    private Long updateById;

    @ApiModelProperty(value = "修改人名字")
    @TableField(value = "update_by_name", fill = FieldFill.INSERT)
    private String updateByName;

    @ApiModelProperty("备注")
    private String note;

}
