package com.yizhi.application.domain;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 经验池等级主体
 * </p>
 *
 * @author dingxiaowei
 * @since 2018-11-01
 */
@Data
@ApiModel(value = "ExperiencePoolLevelVo", description = "")
@TableName("experience_pool_level")
public class ExperiencePoolLevel {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "主键ID")
    private Long id;

    @ApiModelProperty(value = "经验池ID")
    @TableField("experience_pool_id")
    private Long experiencePoolId;

    @ApiModelProperty(value = "等级编码")
    @TableField("level_no")
    private String levelNo;

    @ApiModelProperty(value = "等级名称")
    @TableField("level_name")
    private String levelName;

    @ApiModelProperty(value = "等级对应经验最小值")
    @TableField("min_level_experience")
    private Long minLevelExperience;

    @ApiModelProperty(value = "状态")
    private Integer state;

    @ApiModelProperty(value = "创建时间")
    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "创建人ID")
    @TableField(value = "create_by_id", fill = FieldFill.INSERT)
    private Long createById;

    @ApiModelProperty(value = "创建人名字")
    @TableField(value = "create_by_name", fill = FieldFill.INSERT)
    private String createByName;

    @ApiModelProperty(value = "修改时间")
    @TableField(value = "update_time", fill = FieldFill.INSERT)
    private Date updateTime;

    @ApiModelProperty(value = "修改人ID")
    @TableField(value = "update_by_id", fill = FieldFill.INSERT)
    private Long updateById;

    @ApiModelProperty(value = "修改人名字")
    @TableField(value = "update_by_name", fill = FieldFill.INSERT)
    private String updateByName;


}
