package com.yizhi.application.domain;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 经验发放记录表
 * </p>
 *
 * @author dingxiaowei123
 * @since 2019-01-02
 */
@Data
@ApiModel(value = "ExperienceRecordVo", description = "经验发放记录表")
@TableName("experience_record")
public class ExperienceRecord {

    private static final long serialVersionUID = 1L;


	private Long id;

    @ApiModelProperty(value = "经验池id")
	@TableField("experience_pool_id")
	private Long experiencePoolId;

    @ApiModelProperty(value = "学生id")
	@TableField("account_id")
	private Long accountId;

    @ApiModelProperty(value = "活动类型")
	@TableField("activity_type")
	private Integer activityType;

    @ApiModelProperty(value = "活动id(考试,课程,调研,投票…..)")
	@TableField("activity_id")
	private Long activityId;

    @ApiModelProperty(value = "活动名称")
	@TableField("activity_name")
	private String activityName;

    @ApiModelProperty(value = "产生经验")
	private Integer experience;

	@TableField(value = "create_time", fill = FieldFill.INSERT)
	private Date createTime;

	@TableField(value = "create_by_id", fill = FieldFill.INSERT)
	private Long createById;

	@TableField(value = "create_by_name", fill = FieldFill.INSERT)
	private String createByName;

	@TableField(value = "update_time", fill = FieldFill.INSERT)
	private Date updateTime;

	@TableField(value = "update_by_id", fill = FieldFill.INSERT)
	private Long updateById;

	@TableField(value = "update_by_name", fill = FieldFill.INSERT)
	private String updateByName;



}
