package com.yizhi.application.domain;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 经验池关联项目活动经验值主体
 * </p>
 *
 * @author dingxiaowei
 * @since 2018-11-01
 */
@Data
@ApiModel(value = "ProjectActivityExperienceVo", description = "")
@TableName("project_activity_experience")
public class ProjectActivityExperience {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "主键ID ")
    private Long id;

    @ApiModelProperty(value = "项目关联活动ID")
    @TableField("experience_pool_project_id")
    private Long experiencePoolProjectId;

    @ApiModelProperty(value = "项目类型1 课程 2 考试 3 调研 4 投票 5 外部经验")
    private Integer type;

    @ApiModelProperty(value = "活动名称")
    @TableField("activity_name")
    private String activityName;

    @ApiModelProperty(value = "活动经验来源 0 无其他条件 1 按成绩设置")
    @TableField("activity_experience_source")
    private Integer activityExperienceSource;

    @ApiModelProperty(value = "活动经验值（分值，活动经验值来源为0时取该值，1从经验值条件表中取）")
    @TableField("activity_experience")
    private Long activityExperience;

    @ApiModelProperty(value = "创建时间")
    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "创建人ID")
    @TableField(value = "create_by_id", fill = FieldFill.INSERT)
    private Long createById;

    @ApiModelProperty(value = "创建人名字")
    @TableField(value = "create_by_name", fill = FieldFill.INSERT)
    private String createByName;

    @ApiModelProperty(value = "修改时间")
    @TableField(value = "update_time", fill = FieldFill.INSERT)
    private Date updateTime;

    @ApiModelProperty(value = "修改人ID")
    @TableField(value = "update_by_id", fill = FieldFill.INSERT)
    private Long updateById;

    @ApiModelProperty(value = "修改人名字")
    @TableField(value = "update_by_name", fill = FieldFill.INSERT)
    private String updateByName;

    @ApiModelProperty(value = "是否有经验")
    @TableField(value = "evaluate", fill = FieldFill.INSERT)
    private Integer evaluate;


}
