package com.yizhi.application.domain;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 经验池关联项目活动经验值设计主体
 * </p>
 *
 * @author dingxiaowei
 * @since 2018-11-01
 */
@Data
@ApiModel(value = "ProjectActivityExperienceSetVo", description = "")
@TableName("project_activity_experience_set")
public class ProjectActivityExperienceSet {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "主键")
    private Long id;

    @ApiModelProperty(value = "项目关联经验值表_ID")
    @TableField("project_activity_experience_id")
    private Long projectActivityExperienceId;

    @ApiModelProperty(value = "经验设置类型（1按成绩范围设置，2按成绩值设置）")
    @TableField("set_type")
    private Integer setType;

    @ApiModelProperty(value = "经验规则对应最小分数")
    @TableField("min_score")
    private Integer minScore;

    @ApiModelProperty(value = "经验值")
    private Long experience;

    @ApiModelProperty(value = "按成绩值设置倍数")
    private Integer times;

    @ApiModelProperty(value = "创建时间")
    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "创建人ID")
    @TableField(value = "create_by_id", fill = FieldFill.INSERT)
    private Long createById;

    @ApiModelProperty(value = "创建人名字")
    @TableField(value = "create_by_name", fill = FieldFill.INSERT)
    private String createByName;

    @ApiModelProperty(value = "修改时间")
    @TableField(value = "update_time", fill = FieldFill.INSERT)
    private Date updateTime;

    @ApiModelProperty(value = "修改人ID")
    @TableField(value = "update_by_id", fill = FieldFill.INSERT)
    private Long updateById;

    @ApiModelProperty(value = "修改人名字")
    @TableField(value = "update_by_name", fill = FieldFill.INSERT)
    private String updateByName;


}
