package com.yizhi.application.domain;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 项目关联活动经验值表
 * </p>
 *
 * @author dingxiaowei123
 * @since 2018-11-12
 */
@Data
@ApiModel(value = "StudentExperienceVo", description = "项目关联活动经验值表")
@TableName("student_experience")
public class StudentExperience {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "主键ID ")
    private Long id;

    @ApiModelProperty(value = "经验池ID")
    @TableField("experience_pool_id")
    private Long experiencePoolId;

    @ApiModelProperty(value = "用户ID ")
    private Long accountId;

    @ApiModelProperty(value = "用户名")
    private String accountName;

    @ApiModelProperty(value = "项目类型5 (外部导入)")
    private Integer type;
    
    @TableField("activity_id")
    private Long activityId;
    
    @TableField("activity_name")
    private String activityName;
    
    @ApiModelProperty(value = "活动经验值")
    private Long experience;

    @ApiModelProperty(value = "企业id")
    private Long companyId;

    @ApiModelProperty(value = "站点id")
    private Long siteId;

    @ApiModelProperty(value = "部门id")
    private Long orgId;

    @ApiModelProperty(value = "部门名称")
    private String orgName;

    @ApiModelProperty(value = "创建时间")
    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "创建人ID")
    @TableField(value = "create_by_id", fill = FieldFill.INSERT)
    private Long createById;

    @ApiModelProperty(value = "创建人名字")
    @TableField(value = "create_by_name", fill = FieldFill.INSERT)
    private String createByName;

    @ApiModelProperty(value = "修改时间")
    @TableField(value = "update_time", fill = FieldFill.INSERT)
    private Date updateTime;

    @ApiModelProperty(value = "修改人ID")
    @TableField(value = "update_by_id", fill = FieldFill.INSERT)
    private Long updateById;

    @ApiModelProperty(value = "修改人名字")
    @TableField(value = "update_by_name", fill = FieldFill.INSERT)
    private String updateByName;

    @ApiModelProperty(value = "是否删除 0:删除, 1:未删除")
    @TableField(value = "state", fill = FieldFill.INSERT)
    private Integer state;
}
