package com.yizhi.application.domain;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 学员经验池
 * </p>
 *
 * @author dingxiaowei123
 * @since 2018-11-12
 */
@Data
@ApiModel(value = "StudentExperiencePoolVo", description = "学员经验池")
@TableName("student_experience_pool")
public class StudentExperiencePool {

    @SuppressWarnings("unused")
	private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "主键ID ")
    private Long id;

    @ApiModelProperty(value = "经验池ID")
    @TableField("experience_pool_id")
    private Long experiencePoolId;

    @ApiModelProperty(value = "用户ID")
    @TableField("account_id")
    private Long accountId;
    
    @ApiModelProperty(value = "批次号")
    @TableField("batch_no")
    private String batchNo;
    
    @ApiModelProperty(value = "登录序号（第几个登录的）")
    private Integer num;
    
    @ApiModelProperty(value = "步数")
    private Integer step;
    
    @ApiModelProperty(value = "座右铭")
    private String motto;

    @ApiModelProperty(value = "创建时间")
    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "创建人ID")
    @TableField(value = "create_by_id", fill = FieldFill.INSERT)
    private Long createById;

    @ApiModelProperty(value = "创建人名字")
    @TableField(value = "create_by_name", fill = FieldFill.INSERT)
    private String createByName;

    @ApiModelProperty(value = "修改时间")
    @TableField(value = "update_time", fill = FieldFill.INSERT)
    private Date updateTime;

    @ApiModelProperty(value = "修改人ID")
    @TableField(value = "update_by_id", fill = FieldFill.INSERT)
    private Long updateById;

    @ApiModelProperty(value = "修改人名字")
    @TableField(value = "update_by_name", fill = FieldFill.INSERT)
    private String updateByName;

}
