package com.yizhi.application.mapper;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.custom.api.param.ExperiencePoolParam;
import com.yizhi.custom.api.vo.custom.ExperiencePoolReportVo;
import com.yizhi.application.domain.ExperiencePool;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * <p>
 * 自定义项目经验池主体表 Mapper 接口
 * </p>
 *
 * @author ding
 * @since 2018-11-06
 */
public interface ExperiencePoolMapper extends BaseMapper<ExperiencePool> {

    List<ExperiencePool> getExperiencePoolList(@Param("param") ExperiencePoolParam param, Page<ExperiencePool> page);


    List<ExperiencePoolReportVo> getPoolReportList(@Param("poolName") String poolName,
                                                   @Param("accountIds") List<Long> accountIds,
                                                   @Param("companyId") Long companyId,
                                                   @Param("siteId") Long siteId,
                                                   Page<ExperiencePoolReportVo> page);

    ExperiencePool selectByPoolId(@Param("poolId") Long poolId);
}
