package com.yizhi.application.service;

import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.IService;
import com.yizhi.application.domain.ExperiencePool;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.custom.api.param.ExperiencePoolParam;
import com.yizhi.custom.api.vo.custom.ExperiencePoolVoAutorizeAndProjectVO;
import com.yizhi.custom.api.vo.custom.ExperiencePoolReportExportVo;
import com.yizhi.custom.api.vo.custom.ExperiencePoolReportVo;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 服务类
 * </p>
 *
 * @author ding
 * @since 2018-11-06
 */
public interface IExperiencePoolService extends IService<ExperiencePool> {

    Page<ExperiencePool> getExperiencePoolList(ExperiencePoolParam param);

    ExperiencePoolVoAutorizeAndProjectVO getExperiencePoolView(Long poolId);

    Map<String, Object> insertPoolAuthorizeAndProject(ExperiencePoolVoAutorizeAndProjectVO poolAutorizeAndProjectVO);

    boolean complete(Long poolId);

    Page<ExperiencePoolReportVo> getPoolReportList(String poolName, Integer pageNo, Integer pageSize, RequestContext requestContext);

    Page<ExperiencePoolReportExportVo> getReportViewList(Long poolId, String key, String orgName, Integer pageNo, Integer pageSize, Integer type, String startTime, String endTime, Long siteId, RequestContext requestContext);

    Page<ExperiencePoolReportExportVo> viewAccountDetails(Long poolId, Long accountId, Integer state, Integer pageNo, Integer pageSize);

    List<ExperiencePoolReportExportVo> viewAllDetails(Long poolId, String startTime, String endTime, String orgName, String accountName, Integer state, RequestContext res);
}
