package com.yizhi.application.service;

import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.IService;
import com.yizhi.application.domain.StudentExperience;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.custom.api.vo.custom.ExperienceOrgRankingVO;
import com.yizhi.custom.api.vo.custom.ExperiencePoolExamRuleVo;
import com.yizhi.custom.api.vo.custom.ExperiencePoolRuleVo;

import java.util.List;

/**
 * <p>
 * 项目关联活动经验值表 服务类
 * </p>
 *
 * @author dingxiaowei123
 * @since 2018-11-12`
 */
public interface IStudentExperienceService extends IService<StudentExperience> {

    boolean insertStudentExperienceList(List<StudentExperience> studentExperienceList);

    List<ExperiencePoolRuleVo> getRules(Long activityId, Long compantyId, Long siteId, Long accountId);

    void insertStudentExperience(StudentExperience studentExperience);

    List<ExperiencePoolExamRuleVo> getExamRules(Long activityId, Long compantyId, Long siteId, Long accountId, Integer type);

    boolean pushStudentExperience(Long experiencePoolId, Long activityId, String activityName, Integer activityType, List<Long> accountIds, RequestContext requestContext);


    /**
     * 自定义项目按组织经验排行
     *
     * @param poolId
     * @param pageNo
     * @param pageSize
     * @param type
     * @return
     */
    Page<ExperienceOrgRankingVO> getOrgRanking(Long poolId, Integer pageNo, Integer pageSize, Integer type);

    /**
     * 获得某个用户某个经验池的总经验
     *
     * @param poolId
     * @param accountId
     * @return
     */
    Long getTotalExperience(Long poolId, Long accountId);
}
