package com.yizhi.application.service.impl;

import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.application.domain.CodePackageManage;
import com.yizhi.application.mapper.CodePackageManageMapper;
import com.yizhi.application.service.ICodePackageManageService;
import com.yizhi.custom.api.param.ExperiencePoolParam;
import com.yizhi.application.orm.hierarchicalauthorization.HQueryUtil;

import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author ding
 * @since 2018-11-06
 */
@Service
public class CodePackageManageServiceImpl extends ServiceImpl<CodePackageManageMapper, CodePackageManage> implements ICodePackageManageService {

    @Autowired
    private CodePackageManageMapper packageManageMapper;

    @Override
    public Page<CodePackageManage> getCodePackageManageList(ExperiencePoolParam experiencePoolParam) {
        Long companyId = experiencePoolParam.getCompanyId();
        Long siteId = experiencePoolParam.getSiteId();
        List<Long> orgIds = experiencePoolParam.getOrgIds();
        Integer pageNo = experiencePoolParam.getPageNo();
        Integer pageSize = experiencePoolParam.getPageSize();
        Page<CodePackageManage> page = new Page<>(pageNo, pageSize);
        List<CodePackageManage> list = new ArrayList<>();
        HQueryUtil.startHQ(CodePackageManage.class);
        list = packageManageMapper.getCodePackageManageList(companyId, siteId, orgIds, page);
        if (CollectionUtils.isNotEmpty(list)) {
            page.setRecords(list);
        }
        return page;
    }
}
