package com.yizhi.application.service.impl;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.application.domain.ExperiencePoolAuthorize;
import com.yizhi.application.mapper.ExperiencePoolAuthorizeMapper;
import com.yizhi.application.service.IExperiencePoolAuthorizeService;
import com.yizhi.application.orm.id.IdGenerator;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author ding
 * @since 2018-11-06
 */
@Service
public class ExperiencePoolAuthorizeServiceImpl extends ServiceImpl<ExperiencePoolAuthorizeMapper, ExperiencePoolAuthorize> implements IExperiencePoolAuthorizeService {

    @Autowired
    private IdGenerator idGenerator;

    @Autowired
    private ExperiencePoolAuthorizeMapper poolAuthorizeMapper;

    @Override
    public boolean insertAuthorizeList(List<ExperiencePoolAuthorize> poolAuthorizeList) {
        if (CollectionUtils.isNotEmpty(poolAuthorizeList)) {
            //先把原有列表范围清空
            ExperiencePoolAuthorize experiencePoolAuthorize = new ExperiencePoolAuthorize();
            experiencePoolAuthorize.setExperienceId(poolAuthorizeList.get(0).getExperienceId());
            EntityWrapper<ExperiencePoolAuthorize> entityWrapper = new EntityWrapper<>(experiencePoolAuthorize);
            this.delete(entityWrapper);
            //新列表重新入库
            for (ExperiencePoolAuthorize poolAuthorize : poolAuthorizeList) {
                poolAuthorize.setId(idGenerator.generate());
            }
            return this.insertBatch(poolAuthorizeList);
        }
        return true;
    }

    @Override
    public List<Map<String, Object>> getListMap(Long experiencePoolId) {
        return poolAuthorizeMapper.getListMap(experiencePoolId);
    }
}
