package com.yizhi.application.service.impl;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.application.domain.ExperiencePoolProject;
import com.yizhi.application.domain.ProjectActivityExperience;
import com.yizhi.application.mapper.ExperiencePoolProjectMapper;
import com.yizhi.application.service.IExperiencePoolProjectService;
import com.yizhi.application.service.IProjectActivityExperienceService;
import com.yizhi.core.application.context.ContextHolder;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.application.orm.id.IdGenerator;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author ding
 * @since 2018-11-06
 */
@Service
public class ExperiencePoolProjectServiceImpl extends ServiceImpl<ExperiencePoolProjectMapper, ExperiencePoolProject> implements IExperiencePoolProjectService {

    @Autowired
    private IdGenerator idGenerator;

    @Autowired
    private IProjectActivityExperienceService activityExperienceService;

    @Override
    public List<ProjectActivityExperience> saveList(Long id, List<ExperiencePoolProject> poolProjects) {
        List<ExperiencePoolProject> insertList = null;
        List<Long> deleteList = null;
        List<ExperiencePoolProject> oldList = null;
        List<ProjectActivityExperience> activityExperienceList = null;
        RequestContext res = ContextHolder.get();
        if (CollectionUtils.isNotEmpty(poolProjects)) {
            insertList = new ArrayList<>();
            for (ExperiencePoolProject poolProject : poolProjects) {
                //如果有id跳过
                if (null != poolProject.getId()) {
                    continue;
                }
                //没有id新建
                poolProject.setId(idGenerator.generate());
                poolProject.setExperienceId(id);
                poolProject.setCreateById(res.getAccountId());
                poolProject.setCreateByName(res.getAccountFullName());
                poolProject.setCreateTime(new Date());
                insertList.add(poolProject);
            }
            //获取旧列表判断是否删除
            ExperiencePoolProject experiencePoolProject = new ExperiencePoolProject();
            experiencePoolProject.setExperienceId(id);
            EntityWrapper<ExperiencePoolProject> entityWrapper = new EntityWrapper<>(experiencePoolProject);
            oldList = this.selectList(entityWrapper);
            if (CollectionUtils.isNotEmpty(oldList)) {
                deleteList = new ArrayList<>();
                List<Long> ids = poolProjects.stream().map(ExperiencePoolProject::getId).collect(Collectors.toList());
                for (ExperiencePoolProject oldPoolProject : oldList) {
                    if (ids.contains(oldPoolProject.getId())) {
                        continue;
                    }
                    deleteList.add(oldPoolProject.getId());
                }
            }
            //数据库删除已经删除的关联项目
            if (CollectionUtils.isNotEmpty(deleteList)) {
                this.deleteBatchIds(deleteList);
            }

            //新增数据入库
            if (CollectionUtils.isNotEmpty(insertList)) {
                this.insertBatch(insertList);
            }

            //入库关联项目活动经验
            activityExperienceList = activityExperienceService.saveList(deleteList, poolProjects);

        }
        return activityExperienceList;
    }
}
