package com.yizhi.application.service.impl;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.yizhi.application.domain.ProjectActivityExperience;
import com.yizhi.application.domain.ProjectActivityExperienceSet;
import com.yizhi.application.mapper.ProjectActivityExperienceSetMapper;
import com.yizhi.application.service.IProjectActivityExperienceService;
import com.yizhi.application.service.IProjectActivityExperienceSetService;
import com.yizhi.core.application.context.ContextHolder;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.application.orm.id.IdGenerator;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author ding
 * @since 2018-11-06
 */
@Service
public class ProjectActivityExperienceSetServiceImpl extends ServiceImpl<ProjectActivityExperienceSetMapper, ProjectActivityExperienceSet> implements IProjectActivityExperienceSetService {

    @Autowired
    private IdGenerator idGenerator;

    @Autowired
    private IProjectActivityExperienceService activityExperienceService;

    @Override
    public Map<String, Object> getSets(Long activityExperienceId, Integer setType) {
        Map<String, Object> map = new HashMap<>();
        List<ProjectActivityExperienceSet> activityExperienceSets = new ArrayList<>();
        ProjectActivityExperienceSet activityExperienceSet = new ProjectActivityExperienceSet();
        activityExperienceSet.setProjectActivityExperienceId(activityExperienceId);
        EntityWrapper<ProjectActivityExperienceSet> entityWrapper = new EntityWrapper<>(activityExperienceSet);
        activityExperienceSets = this.selectList(entityWrapper);
        if (CollectionUtils.isNotEmpty(activityExperienceSets)) {
            Integer type = activityExperienceSets.get(0).getSetType();
            map.put("type", type);
            map.put("activityExperienceSets", activityExperienceSets);
        }
        return map;
    }

    @Override
    public Map<String, Object> insertSet(Long activityExperienceSetId, Long activityExperienceId, Integer setType, Integer minScore, Long experience) {

        Map<String, Object> resultMap = new HashMap<>();

        //校验成绩,经验值是否存在
        ProjectActivityExperienceSet activityExperienceSet1 = new ProjectActivityExperienceSet();
        activityExperienceSet1.setMinScore(minScore);
        activityExperienceSet1.setProjectActivityExperienceId(activityExperienceId);
        EntityWrapper<ProjectActivityExperienceSet> entityWrapper1 = new EntityWrapper<>(activityExperienceSet1);
        if (null != activityExperienceSetId) {
            if (this.selectById(activityExperienceSetId).getMinScore() != minScore && CollectionUtils.isNotEmpty(this.selectList(entityWrapper1))) {
                resultMap.put("isOk", false);
                return resultMap;
            } else {
                activityExperienceSet1 = new ProjectActivityExperienceSet();
                activityExperienceSet1.setExperience(experience);
                activityExperienceSet1.setProjectActivityExperienceId(activityExperienceId);
                entityWrapper1 = new EntityWrapper<>(activityExperienceSet1);
                if (this.selectById(activityExperienceSetId).getExperience() != experience && CollectionUtils.isNotEmpty(this.selectList(entityWrapper1))) {
                    resultMap.put("isOk", false);
                    return resultMap;
                } else {
                    resultMap.put("isOk", true);
                }
            }
        } else {
            if (CollectionUtils.isNotEmpty(this.selectList(entityWrapper1))) {
                resultMap.put("isOk", false);
                return resultMap;
            } else {
                activityExperienceSet1 = new ProjectActivityExperienceSet();
                activityExperienceSet1.setExperience(experience);
                activityExperienceSet1.setProjectActivityExperienceId(activityExperienceId);
                entityWrapper1 = new EntityWrapper<>(activityExperienceSet1);
                if (CollectionUtils.isNotEmpty(this.selectList(entityWrapper1))) {
                    resultMap.put("isOk", false);
                    return resultMap;
                } else {
                    resultMap.put("isOk", true);
                }
            }
        }

        ProjectActivityExperienceSet activityExperienceSet = new ProjectActivityExperienceSet();
        RequestContext res = ContextHolder.get();
        activityExperienceSet.setProjectActivityExperienceId(activityExperienceId);
        activityExperienceSet.setSetType(1);
        activityExperienceSet.setMinScore(minScore);
        activityExperienceSet.setExperience(experience);
        ProjectActivityExperience projectActivityExperience1 = new ProjectActivityExperience();
        projectActivityExperience1.setId(activityExperienceId);
        projectActivityExperience1.setActivityExperienceSource(1);
        projectActivityExperience1.setUpdateById(res.getAccountId());
        projectActivityExperience1.setUpdateByName(res.getAccountFullName());
        projectActivityExperience1.setUpdateTime(new Date());
        activityExperienceService.updateById(projectActivityExperience1);

        if (null == activityExperienceSetId) {
            //如果是新建,生成id入库
            Long id = idGenerator.generate();
            activityExperienceSet.setId(id);
            activityExperienceSet.setCreateById(res.getAccountId());
            activityExperienceSet.setCreateByName(res.getAccountFullName());
            activityExperienceSet.setCreateTime(new Date());
            this.insert(activityExperienceSet);
        } else {
            //如果是修改,更新入库
            activityExperienceSet.setId(activityExperienceSetId);
            activityExperienceSet.setUpdateById(res.getAccountId());
            activityExperienceSet.setUpdateByName(res.getAccountFullName());
            activityExperienceSet.setUpdateTime(new Date());
            this.updateById(activityExperienceSet);
        }
        //返回列表按分数从高到低排列,并将对应项目经验对象source改为1
        ProjectActivityExperience projectActivityExperience = new ProjectActivityExperience();
        projectActivityExperience = activityExperienceService.selectById(activityExperienceId);
        projectActivityExperience.setActivityExperienceSource(1);
        projectActivityExperience.setUpdateById(res.getAccountId());
        projectActivityExperience.setUpdateByName(res.getAccountFullName());
        projectActivityExperience.setUpdateTime(new Date());
        activityExperienceService.updateById(projectActivityExperience);

        ProjectActivityExperienceSet projectActivityExperienceSet = new ProjectActivityExperienceSet();
        projectActivityExperienceSet.setProjectActivityExperienceId(activityExperienceId);
        projectActivityExperienceSet.setSetType(1);
        EntityWrapper<ProjectActivityExperienceSet> entityWrapper = new EntityWrapper<>(projectActivityExperienceSet);
        entityWrapper.orderBy("minScore", false);
        resultMap.put("list", this.selectList(entityWrapper));

        return resultMap;
    }

    @Override
    public Map<String, Object> insertSetWithScore(Long activityExperienceSetId, Long activityExperienceId, Integer setType, Integer times) {
        ProjectActivityExperienceSet activityExperienceSet = new ProjectActivityExperienceSet();

        RequestContext res = ContextHolder.get();

        Map<String, Object> map = new HashMap<>();

        ProjectActivityExperience activityExperience = null;

        //如果是按考试范围确定直接将对象的source值返回
        if (setType == 1) {
            activityExperience = activityExperienceService.selectById(activityExperienceId);
            activityExperienceSet.setProjectActivityExperienceId(activityExperienceId);
            activityExperienceSet.setSetType(2);
            EntityWrapper<ProjectActivityExperienceSet> entityWrapper = new EntityWrapper<>(activityExperienceSet);
            this.delete(entityWrapper);
            map.put("activityExperienceId", activityExperienceId);
            map.put("source", activityExperience.getActivityExperienceSource());
        } else if (setType == 2) {
            //如果是新建,新建对象并入库
            if (null == activityExperienceSetId) {
                //如果之前有倍数设置,删除
                ProjectActivityExperienceSet activityExperienceSet1 = new ProjectActivityExperienceSet();
                activityExperienceSet1.setProjectActivityExperienceId(activityExperienceId);
                activityExperienceSet1.setSetType(2);
                this.delete(new EntityWrapper<>(activityExperienceSet1));

                activityExperienceSet.setId(idGenerator.generate());
                activityExperienceSet.setProjectActivityExperienceId(activityExperienceId);
                activityExperienceSet.setTimes(times);
                activityExperienceSet.setSetType(2);
                activityExperienceSet.setCreateById(res.getAccountId());
                activityExperienceSet.setCreateByName(res.getAccountFullName());
                activityExperienceSet.setCreateTime(new Date());
                this.insert(activityExperienceSet);
            } else {
                //如果是修改,找出对象修改并入库
                activityExperienceSet = this.selectById(activityExperienceSetId);
                if (null != times) {
                    activityExperienceSet.setTimes(times);
                }
                activityExperienceSet.setUpdateTime(new Date());
                activityExperienceSet.setUpdateById(res.getAccountId());
                activityExperienceSet.setUpdateByName(res.getAccountFullName());
                this.updateById(activityExperienceSet);
            }
            //如果倍数非空,则将source状态改为1
            if (null != times) {
                activityExperience = activityExperienceService.selectById(activityExperienceId);
                activityExperience.setActivityExperienceSource(1);
                activityExperience.setCreateById(res.getAccountId());
                activityExperience.setUpdateByName(res.getAccountFullName());
                activityExperience.setUpdateTime(new Date());
                activityExperienceService.updateById(activityExperience);
            }
            map.put("activityExperienceId", activityExperienceId);
            map.put("source", 1);
        }
        return map;
    }
}
